/*
 * @version 0.0 18.02.2009
 * @author 	Tobse F
 */
package lib.mylib.util;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import org.newdawn.slick.util.ResourceLoader;

public class LanguageSelector {
	
	private static LanguageSelector selector;
	private static String selectedLanguage = "English";
	private static String languageFileLocation= "res/languages/";
	private static String LanguageFileExtension = ".properties";
	private static Properties langProperties;
	
	private LanguageSelector(String language) {
		langProperties = new Properties();
		try {
			langProperties.load(ResourceLoader.getResourceAsStream(
					languageFileLocation + language + LanguageFileExtension));
	
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		selectedLanguage = language;	
	}
	
	public static String getSelectedLanguage() {
		return selectedLanguage;
	}
	
	public static String setSystemLanguage(){
		String language = System.getProperty("user.language"); //TODO: load mapping from property file 
		if(language.equals("de"))
			setLanguage("German");
		else
			setLanguage("English");
		return selectedLanguage;
	}
	
	public static String getString(String string){
		if(selector == null)
			selector = new LanguageSelector("English");
		return langProperties.getProperty(string);
	}
	
	public static void setLanguage(String language){
		selector = new LanguageSelector(language);
	}

}