/*
 * @version 0.0 19.12.2008
 * @author 	Tobse F
 */
package satteliteGame;

import lib.mylib.math.Range;
import lib.mylib.object.SObject;
import lib.mylib.object.ValueChangedListener;
import lib.mylib.object.ValueEvent;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

public class Bar extends SObject implements ValueChangedListener{
	private int height, width;
	protected Color color = Color.red;
	private Rectangle box, bar;
	protected Range range;
	
	public Bar( int x, int y, int widht, int heigh, Color color) {
		super(x, y);
		this.height = heigh;
		this.width = widht;
		this.color = color;
		box = new Rectangle(x ,y, widht, heigh);
		bar = new Rectangle(x ,y, widht, heigh);
		range = new Range();
	}
	
	public Bar( int x, int y, int widht, int heigh) {
		super(x, y);
		this.height = heigh;
		this.width = widht;
		box = new Rectangle(x ,y, widht, heigh);
		bar = new Rectangle(x ,y, widht, heigh);
		range = new Range();
	}
	
	@Override
	public void render(Graphics g) {
		drawBackground(g);
		drawProgressBar(g);
		drawBorder(g);
	}
	
	private void drawBackground(Graphics g){
		g.setColor(Color.white);
		g.fill(box);
	}
	
	private void drawProgressBar(Graphics g){
		g.setColor(color);
		g.fill(bar);
	}
	
	private void drawBorder(Graphics g){
		g.setLineWidth(2);
		g.setColor(Color.black);
		g.draw(box);
	}
	
	public void setValue(double value) {
		range.setValue(value);
		bar.setWidth((float)getBarLenght(value));
	}
	
	public double getValue() {
		return range.getValue();
	}
	
	private double getBarLenght(double value){
		return (value / (range.lenght())) * width;
	}
	
	public void setRange(double min, double max){
		range.setRange(min, max);
	}

	
	public double getMinValue(){
		return range.getMinValue();
	}
	
	public double getMaxValue(){
		return range.getMaxValue();
	}
	public int getHeight() {
		return height;
	}
	
	public int getWidth() {
		return width;
	}
	
	@Override
	public void valueEvent(ValueEvent event) {
		setValue(event.getValue());
	}

}