/*
 * @version 0.0 17.12.2008
 * @author 	Tobse F
 */
package satteliteGame;

import lib.mylib.ValueSlider;
import lib.mylib.ValueSlider.ValueSliderType;
import lib.mylib.object.SObject;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;

public class Earth extends SObject{
	//private final int r;
	private Image earthShadow;
	private Color warminColor;
	private ValueSlider heat;
	public static int EARTH_R = 120;
	
	public void setEarthShadow(Image earthShadow) {
		this.earthShadow = earthShadow;
		warminColor = new Color(Color.red);
		warminColor.a = 0.5f;
		heat = new ValueSlider(0, 0.56, 20, 2500, ValueSliderType.SLIDE_IN);
		heat.setPause(true);
	}
	
	public Earth(Image image, int x, int y){
		super(image, x , y);
		//r = image.getWidth() / 2;
	}
	
	public void warmUp(){
		heat.setPause(false);
		if(heat.isInverted())
			heat.invert();
	}
	
	@Override
	public void render(Graphics g) {
		g.drawImage(image, x - EARTH_R, y - EARTH_R);
		g.setColor(warminColor);
		g.setBackground(warminColor);
		g.drawImage(image, x - EARTH_R, y - EARTH_R, warminColor);
		earthShadow.drawCentered(x, y);
		//g.setColor(Color.blue);
		//g.fillOval(x - r / 2, y - r / 2, r, r);
	}
	
	@Override
	public void update(int delta) {
		heat.update(delta);
		if(heat.isFinshed() && heat.getValue() == heat.getMaxValue()){
			heat.invert();
		}
		warminColor.a = (float)heat.getValue();
		image.rotate(GameProprties.EARTH_ROTATING_SPEED);
	}
	
}