/*
 * @version 0.0 20.12.2008
 * @author 	Tobse F
 */
package satteliteGame;

import java.io.IOException;

import lib.mylib.MyTimer;
import lib.mylib.math.MyMath;
import lib.mylib.object.SObject;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.particles.ConfigurableEmitter;
import org.newdawn.slick.particles.ParticleIO;
import org.newdawn.slick.particles.ParticleSystem;

public class ShootingStarFactory extends SObject{
	private ParticleSystem shootingstar;
	private MyTimer timer;
	private int speed = 6;
	
	public ShootingStarFactory() {	
		try {
			shootingstar = ParticleIO.loadConfiguredSystem(
					GameProprties.RES_DIR+"shootingstar.xml");
		} catch (IOException e) {}
		timer = new MyTimer(2000, true, true){
			@Override
			protected void timerAction() {
				getNewShootingStar();
			}
		};
	}
	
	public void getNewShootingStar(){
		x = MyMath.getInt(400, 1024);
		y = MyMath.getInt(0, 500);
		timer.setDuration(MyMath.getInt(2500, 15000));
		shootingstar.reset();
	}
	
	@Override
	public void render(Graphics g) {
		shootingstar.render();
	}
	
	@Override
	public void update(int delta) {
		timer.update(delta);
		if(shootingstar.getEmitterCount()>0 && shootingstar.getEmitter(0).isEnabled()){
			((ConfigurableEmitter)shootingstar.getEmitter(0)).setPosition(x, y);
			x-=speed;
			y+=speed;
		}
		if(!timer.isInPause())
			shootingstar.update(delta);
	}

}