/*
 * @version 0.0 20.12.2008
 * @author 	Tobse F
 */
package satteliteGame;

import java.io.IOException;

import lib.mylib.MyTimer;
import lib.mylib.math.MyMath;
import lib.mylib.object.SObject;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.particles.ConfigurableEmitter;
import org.newdawn.slick.particles.ParticleIO;
import org.newdawn.slick.particles.ParticleSystem;

public class StarFactory extends SObject{
	private ParticleSystem starSystem;
	private MyTimer timer;
	private ConfigurableEmitter star;
	
	public StarFactory() {	
		try {
			starSystem = ParticleIO.loadConfiguredSystem(
					GameProprties.RES_DIR+"star01.xml");
		} catch (IOException e) {}
		timer = new MyTimer(300, true, true){
			@Override
			protected void timerAction() {
				getNewShootingStar();
			}
		};
		star = ((ConfigurableEmitter)starSystem.getEmitter(0)).duplicate();
		starSystem.setRemoveCompletedEmitters(true);
	}
	
	public void getNewShootingStar(){
		x = MyMath.getInt(4, 1020);
		y = MyMath.getInt(4, 760);
		ConfigurableEmitter newStar = star.duplicate();
		newStar.setPosition(x, y);
		starSystem.addEmitter(newStar);
	}
	
	@Override
	public void render(Graphics g) {
		starSystem.render();
	}
	
	@Override
	public void update(int delta) {
		timer.update(delta);
		starSystem.update(delta);
	}

}