/*
 * @version 0.0 24.12.2008
 * @author 	Tobse F
 */
package satteliteGame;

import lib.mylib.object.SObject;

public class WarminMechanic extends SObject{
	private WolkFactory wolkFactory;
	private Earth earth;
	private Wolkometer wolkometer;
	private Thermometer thermometer;
	private boolean gameOver = false;
	
	private int  maxWolksBeforeWarming = GameProprties.WOLKS_BEFORE_WARMING;
	private double warminSpeed = GameProprties.WARMING_SPEED;
	
	public WarminMechanic(WolkFactory wolkFactory, Earth earth, Wolkometer wolkometer, 
			Thermometer thermometer) {
		this.wolkFactory = wolkFactory;
		this.earth = earth;
		this.wolkometer = wolkometer;
		this.thermometer = thermometer;
	}
	
	public boolean isGameOver() {
		return gameOver;
	}
	
	@Override
	public void update(int delta) {
		//System.out.println(wolkFactory.getWolkCount());
		wolkometer.setValue((1. / maxWolksBeforeWarming ) * wolkFactory.getWolkCount());
		if(wolkFactory.getWolkCount() >= maxWolksBeforeWarming){
			thermometer.setValue(thermometer.getValue() + 
					(warminSpeed * (wolkFactory.getWolkCount() - maxWolksBeforeWarming)));
			earth.warmUp();
		}
		if(thermometer.getValue() == thermometer.getMaxValue()){
			gameOver = true;
		}
	}

}
