/*
 * @version 0.0 24.12.2008
 * @author 	Tobse F
 */
package satteliteGame;

import lib.mylib.SpriteSheet;
import lib.mylib.ValueSlider;
import lib.mylib.ValueSlider.ValueSliderType;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

public class Wolkometer extends Bar{
	SpriteSheet wolks;
	private float badWolkHeight = 0;
	private double newValue = 0; 
	ValueSlider wolkIntensity;
	
	public Wolkometer(int x, int y, SpriteSheet wolks) {
		super(x, y , wolks.getSprite(0).getWidth(), 
				wolks.getSprite(0).getHeight());
		this.wolks = wolks;
		wolkIntensity = new ValueSlider(0, 0, 100, 800, ValueSliderType.SLIDE_IN);
	}
	
	@Override
	public void render(Graphics g) {
		g.setColor(Color.white);
		g.drawImage(wolks.getSprite(0), x, y);
		g.setClip(new Rectangle(x, y +getHeight()- badWolkHeight, getWidth(), badWolkHeight));
		g.drawImage(wolks.getSprite(1), x, y);
		g.clearClip();
	}

	@Override
	public void setValue(double value) {
		newValue = value;
		if(wolkIntensity.isFinshed()){
			if(newValue > getValue()){
				wolkIntensity.setInvert(false);
				wolkIntensity.setRange(getValue(), newValue);
			}else{
				wolkIntensity.setInvert(true);
				wolkIntensity.setRange(newValue, getValue());
			}
			wolkIntensity.reset();
		}
		this.range.setValue(newValue);
	}
	
	public void stepLeft(){
		
	}
	
	@Override
	public void update(int delta) {
		if(getValue() != newValue && !wolkIntensity.isFinshed()){
			
		}
		wolkIntensity.update(delta);
		//System.out.println(wolkIntensity.getValue());
		
	//	badWolkHeight  =(float)( getHeight() * getValue());
		badWolkHeight  =(float)( getHeight() * wolkIntensity.getValue());
	}
}
