    /*
 * @version 0.0 22.07.2008
 * @author Tobse F
 */
package satteliteGame.start;

import java.util.Properties;

import lib.mylib.Spashscreen;
import lib.mylib.util.LanguageSelector;
import lib.mylib.util.LoadingScreen;
import lib.mylib.util.PropertiesTools;

import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.loading.LoadingList;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.util.Log;

import satteliteGame.GameProprties;
import satteliteGame.MainGame;

public class SatelliteGame extends StateBasedGame {
	
	public SatelliteGame() {
		super("SatelliteGame");
	}

	/**
	 * @param args [0] debugmode (true= window mode, no mouse grabbing, debuginfos, show fps)
	 */
	public static void main(String[] args) {
		Properties argsMap = PropertiesTools.convertArgsToLinkedHashMap(args);
		boolean debug = true;
		boolean fullscreen = Boolean.valueOf(argsMap.getProperty("fullscreen"));
		if (args.length > 0) {
			debug = Boolean.valueOf(argsMap.getProperty("debug"));
		}
		Log.info("Debugmode: " + debug);
		// Log.setVerbose(debug); //debug info logging
		try {
			AppGameContainer game = new AppGameContainer(new SatelliteGame());
			game.setShowFPS(debug);
			game.setMinimumLogicUpdateInterval(25);
			//game.setMaximumLogicUpdateInterval(25);
			game.setDisplayMode(1024, 768, fullscreen);
			game.setClearEachFrame(false);
			game.setIcons(new String[] { "res/icon16.png", "res/icon32.png", "res/icon64.png" });
			game.setMouseGrabbed(!debug);
			LoadingList.setDeferredLoading(true);
			game.start();
		} catch (SlickException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void initStatesList(GameContainer container) throws SlickException {
		int id = 0;
		String langDir = LanguageSelector.getSelectedLanguage().equals("German") ? "ger" : "engl";
		langDir += "/";
		addState(new LoadingScreen(id++));
		addState(new Spashscreen(id++, new Image(GameProprties.RES_DIR + langDir + "spashscreen.jpg")));
		addState(new Spashscreen(id++, new Image(GameProprties.RES_DIR + langDir + "help.jpg")));
		addState(new Spashscreen(id++, new Image(GameProprties.RES_DIR + langDir + "gui_description.jpg")));
		addState(new MainGame(id++));
	}

}